// ZweiDoc.cpp : Implementierung der Klasse CZweiDoc
//

#include "stdafx.h"
#include "Zwei.h"

#include "ZweiDoc.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZweiDoc

IMPLEMENT_DYNCREATE(CZweiDoc, CDocument)

BEGIN_MESSAGE_MAP(CZweiDoc, CDocument)
	//{{AFX_MSG_MAP(CZweiDoc)
	ON_COMMAND(ID_STARTEN, OnStarten)
	ON_COMMAND(ID_LOESCHEN, OnLoeschen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZweiDoc Konstruktion/Destruktion

CZweiDoc::CZweiDoc()
{
	// fr Roys Sichtbereich, im ganzen Programm konstant
	// Ausmae
	nMitte = SICHTWEITE;
	nBreite = 2*SICHTWEITE+1;
	// Markierung
	nUnbekannt = -1;
	nEcke = 0;
	nRand = 1;
	nInnen = 2;

	// Vorgabe der Zugzahl (variabel)
	nZuege = 200;

	// Hallenmae
	ptGroesse.X = 40;
	ptGroesse.Y = 30;

	// Markierungen in Roys Sichtbereich setzen
	memset(arRand,nUnbekannt,sizeof(arRand));
	int x,y;
	// alle Grenzen als Rand markieren
	for (x=0; x<nBreite; x++)
		for (y=0; y<nBreite; y++)
		{
			if (Abstand(x,y,nMitte,nMitte)==SICHTWEITE)
				arRand[x][y] = nRand;
			if (Abstand(x,y,nMitte,nMitte)<SICHTWEITE)
				arRand[x][y] = nInnen;
		}
	// Ecken besonders kennzeichnen
	arRand[nMitte][0]         = nEcke;
	arRand[nMitte][nBreite-1] = nEcke;
	arRand[0][nMitte]         = nEcke;
	arRand[nBreite-1][nMitte] = nEcke;
}

CZweiDoc::~CZweiDoc()
{
}

// Bei Datei/Neu neu erstellen
BOOL CZweiDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CZweiDoc Serialisierung

// Laden und Speichern
void CZweiDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// speichere alle wesentlichen Daten einer Halle
		ar.Write(&ptGroesse, sizeof(ptGroesse));
		ar.Write(&ptStart, sizeof(ptStart));
		ar.Write(&ptZiel, sizeof(ptZiel));
		ar.Write(arHalle, sizeof(arHalle));
	}
	else
	{
		// lade alle wesentlichen Daten einer Halle
		ar.Read(&ptGroesse, sizeof(ptGroesse));
		ar.Read(&ptStart, sizeof(ptStart));
		ar.Read(&ptZiel, sizeof(ptZiel));
		ar.Read(arHalle, sizeof(arHalle));
	}
}

/////////////////////////////////////////////////////////////////////////////
// CZweiDoc Diagnose

#ifdef _DEBUG
void CZweiDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CZweiDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CZweiDoc Befehle


// Suche ausfhren
void CZweiDoc::OnStarten() 
{
	int nFreieZuege = nZuege;

	// Startpunkt eintragen
	ptRoy.X = ptStart.X;
	ptRoy.Y = ptStart.Y;

	// ggf. Roys alte Spur lschen
	OnLoeschen();

	// wiederholen, bis Zielpunkt sichtbar oder Abbruch
	bool bFertig = false;
	while((Entfernung(ptRoy)>SICHTWEITE)&&(!bFertig))
	{
		// besten Zug bestimmen
		ptRoy = FindeBestenZug();

		// wenn Roy einen bereits betreten Punkt wieder anfhrt,
		// hat er sich festgefahren
		if (arHalle[ptRoy.X][ptRoy.Y]==WEGSPUR)
		{
			bFertig = true;
			AfxMessageBox("Festgefahren.");
		}
		else
		{
			// Wegspur eintragen
			arHalle[ptRoy.X][ptRoy.Y] = WEGSPUR;

			// kleine Statistik ausgeben
			CString strAusgabe;
			strAusgabe.Format("Noch %i Zge:\nRoy (%i/%i)\nAbstand zum Ziel: %i",
				               nFreieZuege,ptRoy.X,ptRoy.Y,Entfernung(ptRoy));
			AfxMessageBox(strAusgabe);

			// ein Zug weniger jetzt
			nFreieZuege--;
			// alle Zge verbraucht ?
			if (nFreieZuege==0)
				bFertig = true;
		}

		// Roys Spur anzeigen
		UpdateAllViews(NULL);
	}

	// solange Ziel erreicht oder bis Abbruch
	while((Entfernung(ptRoy)>0)&&(!bFertig))
	{
		// nchster Zug zum Ziel
		ptRoy = ErreicheZiel();

		// wenn Roy einen bereits betreten Punkt wieder anfhrt,
		// hat er sich festgefahren
		if (arHalle[ptRoy.X][ptRoy.Y]==WEGSPUR)
		{
			bFertig = true;
			AfxMessageBox("Festgefahren.");
		}
		else
		{
			// Wegspur eintragen
			arHalle[ptRoy.X][ptRoy.Y] = WEGSPUR;

			// kleine Statistik ausgeben
			CString strAusgabe;
			strAusgabe.Format("Ziel sichtbar\nNoch %i Zge:\nRoy (%i/%i)\n",
				               nFreieZuege,ptRoy.X,ptRoy.Y);
			AfxMessageBox(strAusgabe);

			// ein Zug weniger jetzt
			nFreieZuege--;
			// alle Zge verbraucht ?
			if (nFreieZuege==0)
				bFertig = true;
		}

		// Roys Spur anzeigen
		UpdateAllViews(NULL);
	}

	// Erfolg der Suche ausgeben
	if(Entfernung(ptRoy)==0)
	{
		// Ziel erreicht, Anzahl verbleibender Zge anzeigen
		CString strZuege;
		strZuege.Format("Ziel erreicht, noch %i Zge verfgbar.", nFreieZuege);
		AfxMessageBox(strZuege);
	}
	else if(nFreieZuege==0)
		// alle Zge verbraucht
		AfxMessageBox("Alle Zge aufgebraucht.");
}


// Zug ermitteln Ziel nicht sichtbar
TPunkt CZweiDoc::FindeBestenZug()
{
	const int nMax = INT_MAX;
	int x,y;

	// alle Gegenstnde in Roys Blickfeld ermitteln
	ErstelleBlickfeld(ptRoy);

	// Entfernungen der Grenzen des Sichtbereiches zum Ziel bestimmen
	for (y=0; y<nBreite; y++)
		for (x=0; x<nBreite; x++)
		{
			// davon ausgehen, da kein Rand
			arWege[x][y]=nMax;

			// doch Rand und leer?
			if ((arBlickfeld[x][y]==LEER)&&
				((arRand[x][y]==nRand)||
				 (arRand[x][y]==nEcke)))
			{
				// Punkt in Hallenpunkt umrechnen
				TPunkt ptHilf;
				ptHilf.X = x-nMitte+ptRoy.X;
				ptHilf.Y = y-nMitte+ptRoy.Y;

				// Entfernung bestimmen, wichten
				// arWege[x][y]=Entfernung(ptHilf);

				int xDiff = abs(ptHilf.X-ptZiel.X);
				int yDiff = abs(ptHilf.Y-ptZiel.Y);

				arWege[x][y] = (int)sqrt(xDiff*xDiff+yDiff*yDiff);
			}
		}

	// Wege optimieren
	bool bFertig = false;
	// solange, bis sich nichts mehr ndert
	while (!bFertig)
	{
		// davon ausgehen, da Suche beendet
		bFertig = true;
		
		// Sichtbereich durchlaufen
		for (x=0; x<nBreite; x++)
			for (y=0; y<nBreite; y++)
				// wenn Punkt irgendwann schon mal erreicht
				if (arWege[x][y]!=nMax)
				{
					// alle umliegenden Punkte bentigen 1 Schritt mehr
					int nWeg = arWege[x][y]+1;

					// alle Weglngen der umliegenden Punkte versuchen zu optimieren
					// bei nderung ist Suche noch nicht fertig
					if (WegOptimieren(arWege,x-1,y,nWeg))
						bFertig = false;
					if (WegOptimieren(arWege,x+1,y,nWeg))
						bFertig = false;
					if (WegOptimieren(arWege,x,y-1,nWeg))
						bFertig = false;
					if (WegOptimieren(arWege,x,y+1,nWeg))
						bFertig = false;
				}
	}

/*	// Sichtbereich durchlaufen
	for (y=0; y<nBreite; y++)
		for (x=0; x<nBreite; x++)
			// nur begehbare Punkte untersuchen
			if (arWege[x][y]!=nMax)
			{
				// benachbarte Gegenstnde mit Wegstrafe belegen
				if (arBlickfeld[x-1][y]==GEGENSTAND)
					arWege[x][y]++;
				if (arBlickfeld[x+1][y]==GEGENSTAND)
					arWege[x][y]++;
				if (arBlickfeld[x][y+1]==GEGENSTAND)
					arWege[x][y]++;
				if (arBlickfeld[x][y-1]==GEGENSTAND)
					arWege[x][y]++;
			}
*/
	// kleinste Weglnge der Nachbarn von Roys Punkt bestimmen
	int nMinimum = nMax;
	TPunkt ptErgebnis;

	// Minimierungs-Makro
	// in ptErgebnis wird beste Wegrichtung Roys festgehalten
#define Minimiere(x,y) \
	if (arWege[nMitte+x][nMitte+y]<nMinimum)\
	{ \
		nMinimum = arWege[nMitte+x][nMitte+y]; \
		ptErgebnis.X = x; \
		ptErgebnis.Y = y; \
	} 

	// alle Himmelsrichtungen
	Minimiere(1,0);
	Minimiere(-1,0);
	Minimiere(0,1);
	Minimiere(0,-1);
#undef Minimiere

	// Bewegung in Koordinaten umsetzen
	ptErgebnis.X += ptRoy.X;
	ptErgebnis.Y += ptRoy.Y;

	// Ergebnis der Suche zurckgeben
	return ptErgebnis;
}


// Entfernung zum Ziel ermitteln
int CZweiDoc::Entfernung(TPunkt Punkt)
{
	// Summe der Koordinatendifferenzen
	return abs(Punkt.X-ptZiel.X)+abs(Punkt.Y-ptZiel.Y);
}


// Roys Blickfeld aus der Halle bertragen
void CZweiDoc::ErstelleBlickfeld(TPunkt ptStandpunkt)
{
	// initialsieren
	memset(arBlickfeld,UNSICHTBAR,sizeof(arBlickfeld));

	// Grenzen des Sichtbereiches
	const int nLinks  = ptStandpunkt.X-SICHTWEITE;
	const int nRechts = ptStandpunkt.X+SICHTWEITE;
	const int nOben   = ptStandpunkt.Y-SICHTWEITE;
	const int nUnten  = ptStandpunkt.Y+SICHTWEITE;
	
	// kompletten Sichtbereich in Halle absuchen
	int x,y;
	for (x=nLinks; x<=nRechts; x++)
	{
		// nur wenn innerhalb Halle
		if ((x>=0)&&(x<=ptGroesse.X))
			for (y=nOben; y<=nUnten; y++)
				// nur die sichtbaren Teile interessieren
				if ((y>=0)&&(y<=ptGroesse.Y)&&
					(Abstand(ptStandpunkt.X,ptStandpunkt.Y,x,y)<=SICHTWEITE))
				{
					// bertragen
					arBlickfeld[x-nLinks][y-nOben] = arHalle[x][y];
					// eventuelle Wegspuren verstecken
					if (arHalle[x][y]==WEGSPUR)
						arBlickfeld[x-nLinks][y-nOben] = LEER;
				}
	}
}


// Abstand zweier Punkte
int CZweiDoc::Abstand(int x1,int y1,int x2,int y2)
{
	return (abs(x2-x1)+abs(y2-y1));
}


// einen Punkt bzgl. der Weglnge optimieren
bool CZweiDoc::WegOptimieren(TBlickfeld arFeld, int x, int y, int Weg)
{
	// nur wenn innerhalb des Sichtbereiches
	if ((x<0)||(y<0)||(x>nBreite)||(y>nBreite))
		return false;

	// nur wenn leer und alte Weglnge grer
	if ((arBlickfeld[x][y]==LEER)&&(arFeld[x][y]>Weg))
	{
		arFeld[x][y] = Weg;
		return true;
	}

	// nicht bestimmbar
	return false;
}


// Dokument initialisieren
void CZweiDoc::DeleteContents() 
{
	// Start oben links
	ptStart.X = 0;
	ptStart.Y = 0;

	// Ziel unten rechts
	ptZiel.X = ptGroesse.X-1;
	ptZiel.Y = ptGroesse.Y-1;

	// Halle lschen
	memset(arHalle,LEER,sizeof(arHalle));

	CDocument::DeleteContents();
}


// Zug ermitteln, Ziel sichtbar
TPunkt CZweiDoc::ErreicheZiel()
{
	const int nMax = INT_MAX;
	int x,y;

	// alle Gegenstnde in Roys Blickfeld ermitteln
	ErstelleBlickfeld(ptRoy);

	// Weglngen initialisieren
	for (y=0; y<nBreite; y++)
		for (x=0; x<nBreite; x++)
			arWege[x][y]=nMax;
	// Zielpunkt markieren
	arWege[ptZiel.X-ptRoy.X+nMitte][ptZiel.Y-ptRoy.Y+nMitte] = 0;

	// Wege optimieren
	bool bFertig = false;
	// solange, bis sich nichts mehr ndert
	while (!bFertig)
	{
		// davon ausgehen, da Suche beendet
		bFertig = true;
		
		// Sichtbereich durchlaufen
		for (x=0; x<nBreite; x++)
			for (y=0; y<nBreite; y++)
				// wenn Punkt irgendwann schon mal erreicht
				if (arWege[x][y]!=nMax)
				{
					// alle umliegenden Punkte bentigen 1 Schritt mehr
					int nWeg = arWege[x][y]+1;

					// alle Weglngen der umliegenden Punkte versuchen zu optimieren
					// bei nderung ist Suche noch nicht fertig
					if (WegOptimieren(arWege,x-1,y,nWeg))
						bFertig = false;
					if (WegOptimieren(arWege,x+1,y,nWeg))
						bFertig = false;
					if (WegOptimieren(arWege,x,y-1,nWeg))
						bFertig = false;
					if (WegOptimieren(arWege,x,y+1,nWeg))
						bFertig = false;
				}
	}

	// kleinste Weglnge der Nachbarn von Roys Punkt bestimmen
	int nMinimum = nMax;
	TPunkt ptErgebnis;

	// Minimierungs-Makro
	// in ptErgebnis wird beste Wegrichtung Roys festgehalten
#define Minimiere(x,y) \
	if (arWege[nMitte+x][nMitte+y]<nMinimum)  \
	{ \
		nMinimum = arWege[nMitte+x][nMitte+y]; \
		ptErgebnis.X = x; \
		ptErgebnis.Y = y; \
	} 

	// alle Himmelsrichtungen
	Minimiere(1,0);
	Minimiere(-1,0);
	Minimiere(0,1);
	Minimiere(0,-1);
#undef Minimiere

	// Bewegung in Koordinaten umsetzen
	ptErgebnis.X += ptRoy.X;
	ptErgebnis.Y += ptRoy.Y;

	// Ergebnis der Suche zurckgeben
	return ptErgebnis;
}


// Wegspur lschen
void CZweiDoc::OnLoeschen() 
{
	int x,y;

	// Halle durchlaufen
	for (x=0; x<ptGroesse.X; x++)
		for (y=0; y<ptGroesse.Y; y++)
			// alle Wegspuren beseitigen
			if (arHalle[x][y]==WEGSPUR)
				arHalle[x][y]=LEER;

	// Bildschirmanzeige erneuern
	UpdateAllViews(NULL);
}
