// ZweiDoc.h : Schnittstelle der Klasse CZweiDoc
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ZWEIDOC_H__E2020D49_91D2_11D1_9EC7_444553540000__INCLUDED_)
#define AFX_ZWEIDOC_H__E2020D49_91D2_11D1_9EC7_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


class CZweiDoc : public CDocument
{
protected: // Nur aus Serialisierung erzeugen
	CZweiDoc();
	DECLARE_DYNCREATE(CZweiDoc)

// Attribute
public:

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CZweiDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementierung
public:
	// Anzahl zur Verfgung stehender Zuege
	int nZuege;
	// Markierungen in Roys Sichtbereich
	int nUnbekannt;
	int nInnen;
	int nRand;
	int nEcke;
	// Breite Roys Sichtbereich
	int nBreite;
	// Position Roys innerhalb seines Sichtbereiches
	int nMitte;
	// Grenzen Roy Sichtbereich markiert
	TBlickfeld arRand;
	// zurckzulegende Wege
	TBlickfeld arWege;
	// Startpunkt
	TPunkt ptStart;
	// Zielpunkt
	TPunkt ptZiel;
	// Roys Position
	TPunkt ptRoy;
	// Hallenausmae
	TPunkt ptGroesse;
	// Halle
	THalle arHalle;
	// Hallenausschnitt in Roys Sichtbereich
	TBlickfeld arBlickfeld;

	virtual ~CZweiDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generierte Message-Map-Funktionen
protected:
	//{{AFX_MSG(CZweiDoc)
	afx_msg void OnStarten();
	afx_msg void OnLoeschen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	TPunkt ErreicheZiel();
	bool WegOptimieren(TBlickfeld arFeld, int x, int y, int Weg);
	int Abstand(int x1,int y1,int x2,int y2);
	void ErstelleBlickfeld(TPunkt ptStandpunkt);
	int Entfernung(TPunkt Punkt);
	TPunkt FindeBestenZug();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio fgt zustzliche Deklarationen unmittelbar vor der vorhergehenden Zeile ein.

#endif // !defined(AFX_ZWEIDOC_H__E2020D49_91D2_11D1_9EC7_444553540000__INCLUDED_)
